searchNodes=[{"doc":"Filterable allows to map incoming parameters to filter functions. This module contains functions ( apply_filters/3 , filter_values/2 ) which allow to perform filtering and filterable macro which allows to define available filters using DSL (see Filterable.DSL ).","ref":"Filterable.html","title":"Filterable","type":"module"},{"doc":"","ref":"Filterable.html#apply!/4","title":"Filterable.apply!/4","type":"function"},{"doc":"","ref":"Filterable.html#apply_filters/4","title":"Filterable.apply_filters/4","type":"function"},{"doc":"","ref":"Filterable.html#apply_filters!/4","title":"Filterable.apply_filters!/4","type":"function"},{"doc":"","ref":"Filterable.html#define_module/2","title":"Filterable.define_module/2","type":"macro"},{"doc":"","ref":"Filterable.html#filter_values/3","title":"Filterable.filter_values/3","type":"function"},{"doc":"","ref":"Filterable.html#filterable/2","title":"Filterable.filterable/2","type":"macro"},{"doc":"Contains functions which perform filter values type casting. Each function should return casted value or :error atom.","ref":"Filterable.Cast.html","title":"Filterable.Cast","type":"module"},{"doc":"","ref":"Filterable.Cast.html#atom/2","title":"Filterable.Cast.atom/2","type":"function"},{"doc":"","ref":"Filterable.Cast.html#atom_unchecked/1","title":"Filterable.Cast.atom_unchecked/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#boolean/1","title":"Filterable.Cast.boolean/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#date/1","title":"Filterable.Cast.date/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#datetime/1","title":"Filterable.Cast.datetime/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#float/1","title":"Filterable.Cast.float/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#integer/1","title":"Filterable.Cast.integer/1","type":"function"},{"doc":"","ref":"Filterable.Cast.html#string/1","title":"Filterable.Cast.string/1","type":"function"},{"doc":"Provides DSL for building filters.","ref":"Filterable.DSL.html","title":"Filterable.DSL","type":"module"},{"doc":"","ref":"Filterable.DSL.html#filter/2","title":"Filterable.DSL.filter/2","type":"macro"},{"doc":"Contains macros which allow to define widely used filters. use Filterable.Ecto.Helpers Example: defmodule PostFilters do use Filterable.DSL use Filterable.Ecto.Helpers field :author field :title paginateable per_page : 10 orderable [ :title , :inserted_at ] end","ref":"Filterable.Ecto.Helpers.html","title":"Filterable.Ecto.Helpers","type":"module"},{"doc":"","ref":"Filterable.Ecto.Helpers.html#field/2","title":"Filterable.Ecto.Helpers.field/2","type":"macro"},{"doc":"","ref":"Filterable.Ecto.Helpers.html#limitable/1","title":"Filterable.Ecto.Helpers.limitable/1","type":"macro"},{"doc":"","ref":"Filterable.Ecto.Helpers.html#orderable/1","title":"Filterable.Ecto.Helpers.orderable/1","type":"macro"},{"doc":"","ref":"Filterable.Ecto.Helpers.html#paginateable/1","title":"Filterable.Ecto.Helpers.paginateable/1","type":"macro"},{"doc":"Allows to fetch Map of filterable params. Performs casting/triming/normalization of filter params.","ref":"Filterable.Params.html","title":"Filterable.Params","type":"module"},{"doc":"","ref":"Filterable.Params.html#filter_value/2","title":"Filterable.Params.filter_value/2","type":"function"},{"doc":"Allows to extend Phoenix controller with filterable macros and functions. use Filterable.Phoenix.Controller Example: defmodule MyApp.PostController do use MyApp.Web , :controller use Filterable.Phoenix.Controller filterable do filter author ( query , value , _conn ) do query |&gt; where ( author_name : ^ value ) end end # /posts?author=Kafka def index ( conn , params ) do with { :ok , query , filter_values } &lt;- apply_filters ( Post , conn ) , posts &lt;- Repo . all ( query ) , do : render ( conn , &quot;index.json&quot; , posts : posts , meta : filter_values ) end end","ref":"Filterable.Phoenix.Controller.html","title":"Filterable.Phoenix.Controller","type":"module"},{"doc":"Allows to extend Ecto model with filterable macros and functions. use Filterable.Phoenix.Controller Example: defmodule MyApp.PostController do use MyApp.Web , :controller use Filterable.Phoenix.Controller filterable do filter author ( query , value , _conn ) do query |&gt; where ( author_name : ^ value ) end end # /posts?author=Kafka def index ( conn , params ) do with { :ok , query , filter_values } &lt;- apply_filters ( Post , conn ) , posts &lt;- Repo . all ( query ) , do : render ( conn , &quot;index.json&quot; , posts : posts , meta : filter_values ) end end Works only for Ecto models in Phoenix app. Use use Filterable for Ecto models outside Phoenix app.","ref":"Filterable.Phoenix.Model.html","title":"Filterable.Phoenix.Model","type":"module"},{"doc":"Raises when filter can't be applied.","ref":"Filterable.FilterError.html","title":"Filterable.FilterError","type":"exception"},{"doc":"Filterable allows to map incoming query parameters to filter functions. The goal is to provide minimal and easy to use DSL for building composable queries using incoming parameters. Filterable doesn't depend on external libraries or frameworks and can be used in Phoenix or pure Elixir projects. Inspired by has_scope .","ref":"readme.html","title":"Filterable","type":"extras"},{"doc":"Add filterable to your mix.exs. { :filterable , &quot;~&gt; 0.7.4&quot; }","ref":"readme.html#installation","title":"Filterable - Installation","type":"extras"},{"doc":"Phoenix controller Put use Filterable.Phoenix.Controller inside Phoenix controller or add it into web.ex . It will extend controller module with filterable macro which allows to define filters. Then use apply_filters function inside controller action to filter using defined filters: defmodule MyApp.PostController do use MyApp.Web , :controller use Filterable.Phoenix.Controller filterable do filter author ( query , value , _conn ) do query |&gt; where ( author_name : ^ value ) end @options param : :q filter search ( query , value , _conn ) do query |&gt; where ( [ u ] , ilike ( u . title , ^ &quot;% \#{ value } %&quot; ) ) end @options cast : :integer filter year ( query , value , _conn ) do query |&gt; where ( year : ^ value ) end end # /posts?q=castle&amp;author=Kafka&amp;year=1926 def index ( conn , params ) do with { :ok , query , filter_values } &lt;- apply_filters ( Post , conn ) , posts &lt;- Repo . all ( query ) , do : render ( conn , &quot;index.json&quot; , posts : posts , meta : filter_values ) end end If you prefer to handle errors with exceptions then use apply_filters! : def index ( conn , params ) do { query , filter_values } = apply_filters! ( Post , conn ) render ( conn , &quot;index.json&quot; , posts : Repo . all ( posts ) , meta : filter_values ) end Phoenix model Put use Filterable.Phoenix.Model inside Ecto model module and define filters using filterable macro: defmodule MyApp.Post do use MyApp.Web , :model use Filterable.Phoenix.Model filterable do filter author ( query , value , _conn ) do query |&gt; where ( author_name : ^ value ) end end schema &quot;posts&quot; do ... end end Then call apply_filters function from model module: # /posts?author=Tom def index ( conn , params , conn ) do with { :ok , query , filter_values } &lt;- Post . apply_filters ( conn ) , posts &lt;- Repo . all ( query ) , do : render ( conn , &quot;index.json&quot; , posts : posts , meta : filter_values ) end Separate module Filters could be defined in separate module, just use Filterable.DSL inside module to make it filterable: defmodule PostFilters do use Filterable.DSL use Filterable.Ecto.Helpers field :author field :title paginateable per_page : 10 @options param : :q filter search ( query , value , _conn ) do query |&gt; where ( [ u ] , ilike ( u . title , ^ &quot;% \#{ value } %&quot; ) ) end @options cast : :integer filter year ( query , value , _conn ) do query |&gt; where ( author_name : ^ value ) end end defmodule MyApp.PostController do use MyApp.Web , :controller use Filterable.Phoenix.Controller filterable PostFilters # /posts?q=castle&amp;author=Kafka&amp;year=1926 def index ( conn , params ) do with { :ok , query , filter_values } &lt;- apply_filters ( Post , conn ) , posts &lt;- Repo . all ( query ) , do : render ( conn , &quot;index.json&quot; , posts : posts , meta : filter_values ) end end","ref":"readme.html#usage","title":"Filterable - Usage","type":"extras"},{"doc":"Each defined filter can be tuned with @options module attribute. Just set @options attribute before filter definition. Available options are: :param - allows to set query parameter name, by default same as filter name. Accepts Atom , List , and Keyword values: # /posts?q=castle # =&gt; #Ecto.Query&lt;from p in Post, where: ilike(u.title, ^&quot;%castle%&quot;)&gt; @options param : :q filter search ( query , value , _conn ) do query |&gt; where ( [ u ] , ilike ( u . title , ^ &quot;% \#{ value } %&quot; ) ) end # /posts?sort=name&amp;order=desc # =&gt; #Ecto.Query&lt;from p in Post, order_by: [desc: p.name]&gt; @options param : [ :sort , :order ] , cast : :integer filter search ( query , %{ sort : field , order : order } , _conn ) do query |&gt; order_by ( [ { ^ order , ^ field } ] ) end # /posts?sort[field]=name&amp;sort[order]=desc # =&gt; #Ecto.Query&lt;from p in Post, order_by: [desc: p.name]&gt; @options param : [ sort : [ :field , :order ] ] , cast : :integer filter search ( query , %{ field : field , order : order } , _conn ) do query |&gt; order_by ( [ { ^ order , ^ field } ] ) end :default - allows to set default filter value: # /posts # =&gt; #Ecto.Query&lt;from p in Post, limit: 20&gt; @options default : 20 , cast : :integer filter limit ( query , value , _conn ) do query |&gt; limit ( ^ value ) end # /posts # =&gt; #Ecto.Query&lt;from p in Post, order_by: [desc: p.inserted_at]&gt; @options param : [ :sort , :order ] , default : [ sort : :inserted_at , order : :desc ] , cast : :atom_unchecked filter search ( query , %{ sort : field , order : order } , _conn ) do query |&gt; order_by ( [ { ^ order , ^ field } ] ) end :allow_blank - when true then it allows to trigger filter with blank value ( &quot;&quot; , [] , {} , %{} ). false by default, so all blank values will be converted to nil : # /posts?title=&quot;&quot; # =&gt; #Ecto.Query&lt;from p in Post&gt; @options allow_blank : false filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end # /posts?title=&quot;&quot; # =&gt; #Ecto.Query&lt;from p in Post, where: p.title == &quot;&quot;&gt; @options allow_blank : true filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end :allow_nil - when true then it allows to trigger filter with nil value, false by default: # /posts?title=&quot;&quot; # =&gt; #Ecto.Query&lt;from p in Post, where: is_nil(p.title)&gt; # /posts?title=Casle # =&gt; #Ecto.Query&lt;from p in Post, where: p.title == &quot;Casle&quot;&gt; @options allow_nil : true filter title ( query , nil , _conn ) do query |&gt; where ( [ q ] , is_nil ( q . title ) ) end filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end :trim - allows to remove leading and trailing whitespaces from string values, true by default: # /posts?title=&quot; Casle &quot; # =&gt; #Ecto.Query&lt;from p in Post, where: p.title == &quot;Casle&quot;&gt; filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end # /posts?title=&quot; Casle &quot; # =&gt; #Ecto.Query&lt;from p in Post, where: p.title == &quot; Casle &quot;&gt; @options trim : false filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end :cast - allows to convert value to specific type. Available types are: :integer , :float , :string , {:atom, [...]} , :boolean , :date , :datetime , :atom_unchecked . Casting to atoms is a special case, as atoms are never garbage collected. It is therefore important to give a list of valid atoms. Casting will only work if the given value is in the list of atoms. Also can accept pointer to function: # /posts?limit=20 # =&gt; #Ecto.Query&lt;from p in Post, limit: 20&gt; @options cast : :integer filter limit ( query , value , _conn ) do query |&gt; limit ( ^ value ) end # /posts?title=Casle # =&gt; #Ecto.Query&lt;from p in Post, where: p.title == &quot;casle&quot;&gt; @options cast : &amp; String . downcase / 1 filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end :cast_errors - accepts true (default) or false . If true then it returns error if value can't be caster to specific type. If false - it skips filter if filter value can't be casted: # /posts?inserted_at=Casle # =&gt; {:error, &quot;Unable to cast \\&quot;Casle\\&quot; to datetime&quot;} @options cast : :datetime filter inserted_at ( query , value , _conn ) do query |&gt; where ( inserted_at : ^ value ) end # /posts?inserted_at=Casle # =&gt; #Ecto.Query&lt;from p in Post&gt; @options cast : :datetime , cast_errors : false filter inserted_at ( query , value , _conn ) do query |&gt; where ( inserted_at : ^ value ) end :share - allows to set shared value. When false then filter function will be triggered without shared value argument: @options share : false filter title ( query , value ) do query |&gt; where ( title : ^ value ) end All these options can be specified in apply_filters function or filterable macro. Then they will take affect on all defined filters: filterable share : false , cast_errors : false do field :title end # or filterable PostFilters , share : false , cast_errors : false # or { :ok , query , filter_values } = apply_filters ( conn , share : false , cast_errors : false )","ref":"readme.html#defining-filters","title":"Filterable - Defining filters","type":"extras"},{"doc":"Filterable.Ecto.Helpers module provides macros which allows to define some popular filters: field/2 - expands to simple Ecto.Query.where filter: filterable do field :title field :stars , cast : :integer end Same filters could be built with filter macro: filterable do filter title ( query , value , _conn ) do query |&gt; where ( title : ^ value ) end @options cast : :integer filter stars ( query , value , _conn ) do query |&gt; where ( stars : ^ value ) end end paginateable/1 - provides pagination logic, Default amount of records per page could be tuned with per_page option. By default it's set to 20: filterable do # /posts?page=3 # =&gt; #Ecto.Query&lt;from p in Post, limit: 10, offset: 20&gt; paginateable per_page : 10 end limitable/1 - provides limit/offset logic: filterable do # /posts?limit=3offset=10 # =&gt; #Ecto.Query&lt;from p in Post, limit: 3, offset: 10&gt; limitable limit : 10 end orderable/1 - provides sorting logic, accepts list of atoms: filterable do # /posts?sort=inserted_at&amp;order=asc # =&gt; #Ecto.Query&lt;from p in Post, order_by: [asc: p.inserted_at]&gt; orderable [ :title , :inserted_at ] end","ref":"readme.html#ecto-helpers","title":"Filterable - Ecto helpers","type":"extras"},{"doc":"Filterable also can be used in non Ecto/Phoenix projects. Put use Filterable.DSL inside module to start defining filters: defmodule RepoFilters do use Filterable.DSL filter name ( list , value ) do list |&gt; Enum . filter ( &amp; &amp;1 . name == value ) end @options cast : :integer filter stars ( list , value ) do list |&gt; Enum . filter ( &amp; &amp;1 . stars &gt;= value ) end end Then filter collection using apply_filters function: repos = [ %{ name : &quot;phoenix&quot; , stars : 8565 } , %{ name : &quot;ecto&quot; , start : 2349 } ] { :ok , result , filter_values } = RepoFilters . apply_filters ( repos , %{ name : &quot;phoenix&quot; , stars : &quot;8000&quot; } ) # or { :ok , result , filter_values } = Filterable . apply_filters ( repos , %{ name : &quot;phoenix&quot; , stars : &quot;8000&quot; } , RepoFilters )","ref":"readme.html#common-usage","title":"Filterable - Common usage","type":"extras"},{"doc":"filter macro and phoenix helpers like orderable , paginateable are the part fo DSL so there is no need to wrap them in parentheses. Just add the following line into formatter configs: [ # ... import_deps : [ :filterable ] ]","ref":"readme.html#code-formatter","title":"Filterable - Code formatter","type":"extras"},{"doc":"filterex rumage_ecto inquisitor ex_sieve","ref":"readme.html#similar-packages","title":"Filterable - Similar packages","type":"extras"},{"doc":"Feel free to send your PR with proposals, improvements or corrections 😉","ref":"readme.html#contribution","title":"Filterable - Contribution","type":"extras"}]